diff --git a/src/main/java/net/minecraft/client/render/block/color/BlockColorGrass.java b/src/main/java/net/minecraft/client/render/block/color/BlockColorGrass.java
index 6c8463775..6a51cb2ca 100644
--- a/src/main/java/net/minecraft/client/render/block/color/BlockColorGrass.java
+++ b/src/main/java/net/minecraft/client/render/block/color/BlockColorGrass.java
@@ -1,7 +1,7 @@
 package net.minecraft.client.render.block.color;
 
 import net.minecraft.client.render.colorizer.ColorizerGrass;
-import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.noise.ImprovedNoise;
 import net.minecraft.core.world.season.Season;
 import net.minecraft.core.world.season.Seasons;
@@ -20,22 +20,22 @@ public class BlockColorGrass
     }
 
     @Override
-    public int getWorldColor(World world, int x, int y, int z)
+    public int getWorldColor(WorldSource world, int x, int y, int z)
     {
         double localTemperature = world.getBlockTemperature(x, z);
         double localHumidity = world.getBlockHumidity(x, z);
         int baseGrassColor = ColorizerGrass.getGrassColor(localTemperature, localHumidity);
-        Season season = world.seasonManager.getCurrentSeason();
+        Season season = world.getSeasonManager().getCurrentSeason();
         if (season != null)
         {
             boolean isWinter = (season == Seasons.OVERWORLD_WINTER || season == Seasons.OVERWORLD_WINTER_ENDLESS);
 
-            float progress = world.seasonManager.getSeasonProgress();
+            float progress = world.getSeasonManager().getSeasonProgress();
             if(isWinter){
                 baseGrassColor = ColorizerGrass.getGrassColor((localTemperature*progress), localHumidity);
             }
 
-            baseGrassColor = season.modifyGrassColorizer(baseGrassColor, progress > 0.5f ? world.seasonManager.getNextSeason() : world.seasonManager.getPreviousSeason(), Math.abs(progress - 0.5f));
+            baseGrassColor = season.modifyGrassColorizer(baseGrassColor, progress > 0.5f ? world.getSeasonManager().getNextSeason() : world.getSeasonManager().getPreviousSeason(), Math.abs(progress - 0.5f));
 
             if(isWinter){
                 float offsetIntensity = 1 - Math.abs((progress) - 1);
diff --git a/src/main/java/net/minecraft/client/render/block/color/BlockColorLeaves.java b/src/main/java/net/minecraft/client/render/block/color/BlockColorLeaves.java
index 4ef53cf01..66a20d732 100644
--- a/src/main/java/net/minecraft/client/render/block/color/BlockColorLeaves.java
+++ b/src/main/java/net/minecraft/client/render/block/color/BlockColorLeaves.java
@@ -3,7 +3,7 @@ package net.minecraft.client.render.block.color;
 import net.minecraft.client.render.colorizer.ColorProperties;
 import net.minecraft.client.render.colorizer.ColorizerFoliage;
 import net.minecraft.client.render.colorizer.LeavesColorProperties;
-import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.season.Season;
 
 public class BlockColorLeaves
@@ -25,7 +25,7 @@ public class BlockColorLeaves
     }
 
     @Override
-    public int getWorldColor(World world, int x, int y, int z)
+    public int getWorldColor(WorldSource world, int x, int y, int z)
     {
         LeavesColorProperties color = ColorProperties.getLeavesColor(colorId);
         if (color == null) return 0xFFFFFF;
@@ -34,10 +34,10 @@ public class BlockColorLeaves
         {
             double temp = world.getBlockTemperature(x, z);
             double hum = world.getBlockHumidity(x, z);
-            Season season = world.seasonManager.getCurrentSeason();
+            Season season = world.getSeasonManager().getCurrentSeason();
             if (season != null)
             {
-                float progress = world.seasonManager.getSeasonProgress();
+                float progress = world.getSeasonManager().getSeasonProgress();
                 foliageColor = ColorizerFoliage.getSeasonalColor(season, progress, temp, hum, color);
             }
         }
diff --git a/src/main/java/net/minecraft/client/render/block/color/BlockColorLeavesOak.java b/src/main/java/net/minecraft/client/render/block/color/BlockColorLeavesOak.java
index 2cfe538df..b002e3780 100644
--- a/src/main/java/net/minecraft/client/render/block/color/BlockColorLeavesOak.java
+++ b/src/main/java/net/minecraft/client/render/block/color/BlockColorLeavesOak.java
@@ -3,7 +3,7 @@ package net.minecraft.client.render.block.color;
 import net.minecraft.client.render.colorizer.ColorProperties;
 import net.minecraft.client.render.colorizer.ColorizerFoliage;
 import net.minecraft.client.render.colorizer.LeavesColorProperties;
-import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.noise.ImprovedNoise;
 import net.minecraft.core.world.season.Season;
 import net.minecraft.core.world.season.Seasons;
@@ -21,7 +21,7 @@ public class BlockColorLeavesOak
     }
 
     @Override
-    public int getWorldColor(World world, int x, int y, int z)
+    public int getWorldColor(WorldSource world, int x, int y, int z)
     {
         LeavesColorProperties color = ColorProperties.getLeavesColor(colorId);
         if (color == null) return 0xFFFFFF;
@@ -30,10 +30,10 @@ public class BlockColorLeavesOak
         {
             double temp = world.getBlockTemperature(x, z);
             double hum = world.getBlockHumidity(x, z);
-            Season season = world.seasonManager.getCurrentSeason();
+            Season season = world.getSeasonManager().getCurrentSeason();
             if (season != null)
             {
-                float progress = world.seasonManager.getSeasonProgress();
+                float progress = world.getSeasonManager().getSeasonProgress();
                 foliageColor = ColorizerFoliage.getSeasonalColor(season, progress, temp, hum, color, true);
                 if (season == Seasons.OVERWORLD_FALL)
                 {
diff --git a/src/main/java/net/minecraft/client/render/block/color/BlockColorRedstoneWire.java b/src/main/java/net/minecraft/client/render/block/color/BlockColorRedstoneWire.java
index 2ac50e4d3..6aabcc46e 100644
--- a/src/main/java/net/minecraft/client/render/block/color/BlockColorRedstoneWire.java
+++ b/src/main/java/net/minecraft/client/render/block/color/BlockColorRedstoneWire.java
@@ -1,7 +1,7 @@
 package net.minecraft.client.render.block.color;
 
 import net.minecraft.client.util.helper.Colors;
-import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
 
 public class BlockColorRedstoneWire
     extends BlockColor
@@ -14,7 +14,7 @@ public class BlockColorRedstoneWire
     }
 
     @Override
-    public int getWorldColor(World world, int x, int y, int z)
+    public int getWorldColor(WorldSource world, int x, int y, int z)
     {
         // Colored by renderer
     	return Colors.allRedstoneColors[15].getARGB();
diff --git a/src/main/java/net/minecraft/client/render/block/color/BlockColorTallGrass.java b/src/main/java/net/minecraft/client/render/block/color/BlockColorTallGrass.java
index 901165a44..6ca6f3d1a 100644
--- a/src/main/java/net/minecraft/client/render/block/color/BlockColorTallGrass.java
+++ b/src/main/java/net/minecraft/client/render/block/color/BlockColorTallGrass.java
@@ -2,19 +2,16 @@ package net.minecraft.client.render.block.color;
 
 import net.minecraft.core.block.Block;
 import net.minecraft.client.render.colorizer.ColorizerGrass;
-import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.season.Season;
 import net.minecraft.core.world.season.Seasons;
-import org.lwjgl.Sys;
-
-import java.util.Random;
 
 public class BlockColorTallGrass
     extends BlockColorGrass
 {
     @Override
-    public int getWorldColor(World world, int x, int y, int z)
+    public int getWorldColor(WorldSource world, int x, int y, int z)
     {
 
         double localTemperature = world.getBlockTemperature(x, z);
@@ -33,78 +30,74 @@ public class BlockColorTallGrass
         localHumidity += offsetH;
 
         int baseGrassColor = ColorizerGrass.getGrassColor(localTemperature, localHumidity);
-        if (world != null)
-        {
-            if(world.getBlockBiome(x, y - 1, z) == Biomes.OVERWORLD_CAATINGA){
-
-                Season season = world.seasonManager.getCurrentSeason();
-                if (season != null)
-                {
-                    boolean ishumid = (season == Seasons.OVERWORLD_WINTER || season == Seasons.OVERWORLD_WINTER_ENDLESS || season == Seasons.OVERWORLD_FALL);
-                    float progress = world.seasonManager.getSeasonProgress();
-
-                    if(ishumid){
-                        baseGrassColor = ColorizerGrass.getGrassColor(1.0, 1.0);
-                    } else {
-                        baseGrassColor = ColorizerGrass.getGrassColor(1.0, 0.0);
-                    }
-                    baseGrassColor = season.modifyGrassColorizer(baseGrassColor, progress > 0.5f ? world.seasonManager.getNextSeason() : world.seasonManager.getPreviousSeason(), Math.abs(progress - 0.5f));
-                }
-                return baseGrassColor;
-            }
+        if (world.getBlockBiome(x, y - 1, z) == Biomes.OVERWORLD_CAATINGA) {
 
-        	int blockBelow = world.getBlockId(x, y - 1, z);
-            if(blockBelow == Block.grassScorched.id || blockBelow == Block.dirtScorched.id || blockBelow == Block.dirtScorchedRich.id ){
+            Season season = world.getSeasonManager().getCurrentSeason();
+            if (season != null) {
+                boolean ishumid = (season == Seasons.OVERWORLD_WINTER || season == Seasons.OVERWORLD_WINTER_ENDLESS || season == Seasons.OVERWORLD_FALL);
+                float progress = world.getSeasonManager().getSeasonProgress();
 
-                return 0xffcc58;
+                if (ishumid) {
+                    baseGrassColor = ColorizerGrass.getGrassColor(1.0, 1.0);
+                } else {
+                    baseGrassColor = ColorizerGrass.getGrassColor(1.0, 0.0);
+                }
+                baseGrassColor = season.modifyGrassColorizer(baseGrassColor, progress > 0.5f ? world.getSeasonManager().getNextSeason() : world.getSeasonManager().getPreviousSeason(), Math.abs(progress - 0.5f));
             }
-            Season season = world.seasonManager.getCurrentSeason();
-            if (season != null)
-            {
+            return baseGrassColor;
+        }
 
-                boolean isWinter = (season == Seasons.OVERWORLD_WINTER || season == Seasons.OVERWORLD_WINTER_ENDLESS);
+        int blockBelow = world.getBlockId(x, y - 1, z);
+        if(blockBelow == Block.grassScorched.id || blockBelow == Block.dirtScorched.id || blockBelow == Block.dirtScorchedRich.id ){
 
+            return 0xffcc58;
+        }
+        Season season = world.getSeasonManager().getCurrentSeason();
+        if (season != null)
+        {
 
-                float progress = world.seasonManager.getSeasonProgress();
+            boolean isWinter = (season == Seasons.OVERWORLD_WINTER || season == Seasons.OVERWORLD_WINTER_ENDLESS);
 
-                if(isWinter){
-                    baseGrassColor = ColorizerGrass.getGrassColor(localTemperature*progress, localHumidity);
-                }
 
-                baseGrassColor = season.modifyGrassColorizer(baseGrassColor, progress > 0.5f ? world.seasonManager.getNextSeason() : world.seasonManager.getPreviousSeason(), Math.abs(progress - 0.5f));
+            float progress = world.getSeasonManager().getSeasonProgress();
+
+            if(isWinter){
+                baseGrassColor = ColorizerGrass.getGrassColor(localTemperature*progress, localHumidity);
+            }
 
-                if(isWinter){
-                    float offsetIntensity = 1 - Math.abs((progress*2F) - 1);
-                    float red = ((baseGrassColor & 0xFF0000) >> 16) / 255F;
-                    float green = ((baseGrassColor & 0x00FF00) >> 8) / 255F;
-                    float blue = (baseGrassColor & 0x0000FF) / 255F;
+            baseGrassColor = season.modifyGrassColorizer(baseGrassColor, progress > 0.5f ? world.getSeasonManager().getNextSeason() : world.getSeasonManager().getPreviousSeason(), Math.abs(progress - 0.5f));
 
-                    float gray = red * green * blue / 3;
-                    float grayOffset = (float)grassColorPerlin.getValue(x / 30D, y / 50D, z / 30D) * offsetIntensity * 0.5f;
-                    if (gray + grayOffset > 0.4f) grayOffset = 0.4f - gray;
-                    if (gray + grayOffset < 0.0f) grayOffset = -gray;
+            if(isWinter){
+                float offsetIntensity = 1 - Math.abs((progress*2F) - 1);
+                float red = ((baseGrassColor & 0xFF0000) >> 16) / 255F;
+                float green = ((baseGrassColor & 0x00FF00) >> 8) / 255F;
+                float blue = (baseGrassColor & 0x0000FF) / 255F;
 
-                    red = ((red + grayOffset));
-                    green = ((green + grayOffset));
-                    blue = ((blue + grayOffset));
+                float gray = red * green * blue / 3;
+                float grayOffset = (float)grassColorPerlin.getValue(x / 30D, y / 50D, z / 30D) * offsetIntensity * 0.5f;
+                if (gray + grayOffset > 0.4f) grayOffset = 0.4f - gray;
+                if (gray + grayOffset < 0.0f) grayOffset = -gray;
 
-                    if (red < 0) red = 0;
-                    if (red > 1) red = 1;
-                    if (green < 0) green = 0;
-                    if (green > 1) green = 1;
-                    if (blue < 0) blue = 0;
-                    if (blue > 1) blue = 1;
+                red = ((red + grayOffset));
+                green = ((green + grayOffset));
+                blue = ((blue + grayOffset));
 
-                    int newRed = (int) (red * 255) & 0xFF;
-                    int newGreen = (int) (green * 255) & 0xFF;
-                    int newBlue = (int) (blue * 255) & 0xFF;
+                if (red < 0) red = 0;
+                if (red > 1) red = 1;
+                if (green < 0) green = 0;
+                if (green > 1) green = 1;
+                if (blue < 0) blue = 0;
+                if (blue > 1) blue = 1;
 
+                int newRed = (int) (red * 255) & 0xFF;
+                int newGreen = (int) (green * 255) & 0xFF;
+                int newBlue = (int) (blue * 255) & 0xFF;
 
-                    baseGrassColor = ((newRed << 16) | (newGreen << 8) | (newBlue));
 
-                }
+                baseGrassColor = ((newRed << 16) | (newGreen << 8) | (newBlue));
 
             }
+
         }
         return baseGrassColor;
     }
diff --git a/src/main/java/net/minecraft/client/render/block/color/BlockColorWater.java b/src/main/java/net/minecraft/client/render/block/color/BlockColorWater.java
index f982008b7..83103fa06 100644
--- a/src/main/java/net/minecraft/client/render/block/color/BlockColorWater.java
+++ b/src/main/java/net/minecraft/client/render/block/color/BlockColorWater.java
@@ -2,7 +2,7 @@ package net.minecraft.client.render.block.color;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.colorizer.ColorizerWater;
-import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
 
 public class BlockColorWater
     extends BlockColor
@@ -19,7 +19,7 @@ public class BlockColorWater
     }
 
     @Override
-    public int getWorldColor(World world, int x, int y, int z)
+    public int getWorldColor(WorldSource world, int x, int y, int z)
     {
         if (world != null) {
             if (Minecraft.getMinecraft(this).gameSettings.biomeWater.value)
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelAlgae.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelAlgae.java
index e9ce159d6..8b5ecff40 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelAlgae.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelAlgae.java
@@ -14,16 +14,16 @@ public class BlockModelAlgae<T extends Block> extends BlockModelStandard<T>{
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.world, x, y, z);
-        float brightness = Math.min(getBlockBrightness(renderBlocks.world, x, y - 1, z), getBlockBrightness(renderBlocks.world, x, y, z));
+        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
+        float brightness = Math.min(getBlockBrightness(renderBlocks.blockAccess, x, y - 1, z), getBlockBrightness(renderBlocks.blockAccess, x, y, z));
 
-        int color = BlockColorDispatcher.getInstance().getDispatch(block).getWorldColor(renderBlocks.world, x, y, z);
+        int color = BlockColorDispatcher.getInstance().getDispatch(block).getWorldColor(renderBlocks.blockAccess, x, y, z);
         float red = (float)(color >> 16 & 0xff) / 255F;
         float green = (float)(color >> 8 & 0xff) / 255F;
         float blue = (float)(color & 0xff) / 255F;
 
         tessellator.setColorOpaque_F(red * brightness, green * brightness, blue * brightness);
-        IconCoordinate tex = getBlockTextureFromSideAndMetadata(Side.TOP, renderBlocks.world.getBlockMetadata(x, y, z));
+        IconCoordinate tex = getBlockTextureFromSideAndMetadata(Side.TOP, renderBlocks.blockAccess.getBlockMetadata(x, y, z));
         renderTopFace(tessellator, block, x, y - 0.1125, z, tex);
         renderBottomFace(tessellator, block, x, y + 0.0125, z, tex);
 
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelAxisAligned.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelAxisAligned.java
index bebc6d9c4..32bc85486 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelAxisAligned.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelAxisAligned.java
@@ -15,7 +15,7 @@ public class BlockModelAxisAligned<T extends Block> extends BlockModelStandard<T
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.world, x, y, z);
+        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         int l = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
         int i1 = BlockRotatable.getOrientation(l);
         switch(i1)
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelBasket.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelBasket.java
index 17a0c8acc..2a6a6c09c 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelBasket.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelBasket.java
@@ -15,7 +15,7 @@ public class BlockModelBasket<T extends BlockBasket> extends BlockModelStandard<
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.world, x, y, z);
+        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         // Render basket
         final float onePix = 1.0f / 16;
         final float basketHeight = onePix * 16;
@@ -43,7 +43,7 @@ public class BlockModelBasket<T extends BlockBasket> extends BlockModelStandard<
         block.setBlockBounds(0.0f, 0.0f, 0.0f, 1.0f, 1.0f, 1.0f);
         renderBlocks.renderBitMask = 0;
 
-        final int height = block.getFillLevel(renderBlocks.world, x, y, z);
+        final int height = block.getFillLevel(renderBlocks.blockAccess, x, y, z);
         // Interior
         if (height > 0)
         {
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelBed.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelBed.java
index 010107def..5287840ee 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelBed.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelBed.java
@@ -22,7 +22,7 @@ public class BlockModelBed<T extends Block> extends BlockModelStandard<T>{
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.world, x, y, z);
+        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         renderBlocks.enableAO = true;
         renderBlocks.cache.setupCache(block, renderBlocks.blockAccess, x, y, z);
 
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelCacaoLeaves.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelCacaoLeaves.java
index 614059c19..82808cfed 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelCacaoLeaves.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelCacaoLeaves.java
@@ -21,7 +21,7 @@ public class BlockModelCacaoLeaves<T extends Block> extends BlockModelLeaves<T>{
         super.render(tessellator, x, y, z);
 
         final int growthRate = (renderBlocks.blockAccess.getBlockMetadata(x, y, z) & 0XF0) >> 4;
-        final float brightness = getBlockBrightness(renderBlocks.world, x, y, z);
+        final float brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
 
         final float cNorthSouth = 0.8F;
         final float cEastWest = 0.6F;
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelCactus.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelCactus.java
index 9080f8610..0369abe10 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelCactus.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelCactus.java
@@ -13,7 +13,7 @@ public class BlockModelCactus<T extends Block> extends BlockModelStandard<T> {
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.world, x, y, z);
+        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
 
         final float sidesOffset = 0.0625F;
 
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelCandle.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelCandle.java
index dc17d6ecd..963f4b0c9 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelCandle.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelCandle.java
@@ -12,9 +12,9 @@ public class BlockModelCandle<T extends Block> extends BlockModelStandard<T> {
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.world, x, y, z);
-        boolean isLit = (renderBlocks.world.getBlockMetadata(x, y, z) & 0b00000001) == 0;
-        float brightness = isLit ? 1.0f : getBlockBrightness(renderBlocks.world, x, y, z);
+        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
+        boolean isLit = (renderBlocks.blockAccess.getBlockMetadata(x, y, z) & 0b00000001) == 0;
+        float brightness = isLit ? 1.0f : getBlockBrightness(renderBlocks.blockAccess, x, y, z);
 
         float minX = x + 0.5f - (1.5f / 16f);
         float minY = y + 0f;
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsPumpkin.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsPumpkin.java
index 9d7577f8f..71d700e1b 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsPumpkin.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsPumpkin.java
@@ -28,7 +28,7 @@ public class BlockModelCropsPumpkin<T extends Block> extends BlockModelStandard<
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.world, x, y, z);
+        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
 
         final float brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
         tessellator.setColorOpaque_F(brightness, brightness, brightness);
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsWheat.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsWheat.java
index 2ba8795ff..98702a48c 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsWheat.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsWheat.java
@@ -25,7 +25,7 @@ public class BlockModelCropsWheat<T extends Block> extends BlockModelStandard<T>
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.world, x, y, z);
+        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         float brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
         tessellator.setColorOpaque_F(brightness, brightness, brightness);
 
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelCrossedSquares.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelCrossedSquares.java
index d3523ecf5..0ae77411c 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelCrossedSquares.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelCrossedSquares.java
@@ -75,10 +75,10 @@ public class BlockModelCrossedSquares<T extends Block> extends BlockModelStandar
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.world, x, y, z);
+        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
 
         float brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
-        int color = BlockColorDispatcher.getInstance().getDispatch(block).getWorldColor(renderBlocks.world, x, y, z);
+        int color = BlockColorDispatcher.getInstance().getDispatch(block).getWorldColor(renderBlocks.blockAccess, x, y, z);
         float r = (float)(color >> 16 & 0xff) / 255F;
         float g = (float)(color >> 8 & 0xff) / 255F;
         float b = (float)(color & 0xff) / 255F;
@@ -98,7 +98,7 @@ public class BlockModelCrossedSquares<T extends Block> extends BlockModelStandar
             zd += ((double)((float)(dRandom >> 24 & 15L) / 15F) - 0.5D) * 0.5D;
         }
 
-        int metadata = renderBlocks.world.getBlockMetadata(x, y, z);
+        int metadata = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
         IconCoordinate texIndex = getBlockTextureFromSideAndMetadata(Side.BOTTOM, metadata);
         if(renderBlocks.overrideBlockTexture != null)
         {
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
index de5da1b0b..9448bae27 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
@@ -205,6 +205,9 @@ public class BlockModelDispatcher
 
         addDispatch(new BlockModelCrossedSquares<>(Block.flowerYellow).withTextures("minecraft:block/flower_yellow"));
         addDispatch(new BlockModelCrossedSquares<>(Block.flowerRed).withTextures("minecraft:block/flower_red"));
+        addDispatch(new BlockModelCrossedSquares<>(Block.flowerPink).withTextures("minecraft:block/flower_pink"));
+        addDispatch(new BlockModelCrossedSquares<>(Block.flowerPurple).withTextures("minecraft:block/flower_purple"));
+        addDispatch(new BlockModelCrossedSquares<>(Block.flowerLightBlue).withTextures("minecraft:block/flower_light_blue"));
 
         addDispatch(new BlockModelCrossedSquares<>(Block.mushroomBrown).withTextures("minecraft:block/mushroom_brown"));
         addDispatch(new BlockModelCrossedSquares<>(Block.mushroomRed).withTextures("minecraft:block/mushroom_red"));
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java
index 4f920b277..ae120f600 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java
@@ -13,15 +13,15 @@ public class BlockModelDoor<T extends BlockDoor> extends BlockModelStandard<T>{
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.world, x, y, z);
+        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         float f = 0.5F;
         float f1 = 1.0F;
         float f2 = 0.8F;
         float f3 = 0.6F;
         float f4 = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
         float f5 = getBlockBrightness(renderBlocks.blockAccess, x, y - 1, z);
-        boolean aboveIsDoor = renderBlocks.world.getBlock(x, y + 1, z) instanceof BlockDoor;
-        boolean belowIsDoor = renderBlocks.world.getBlock(x, y - 1, z) instanceof BlockDoor;
+        boolean aboveIsDoor = renderBlocks.blockAccess.getBlock(x, y + 1, z) instanceof BlockDoor;
+        boolean belowIsDoor = renderBlocks.blockAccess.getBlock(x, y - 1, z) instanceof BlockDoor;
         int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
         if(block.minY > 0.0D)
         {
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelFence.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelFence.java
index 7352c28ca..17d331b43 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelFence.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelFence.java
@@ -14,7 +14,7 @@ public class BlockModelFence<T  extends BlockFence> extends BlockModelStandard<T
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.world, x, y, z);
+        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         final float f = 0.375F;
         final float f1 = 0.625F;
         block.setBlockBounds(f, 0.0F, f, f1, 1.0F, f1);
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceGate.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceGate.java
index 94ad81c15..e641ffcf0 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceGate.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceGate.java
@@ -14,7 +14,7 @@ public class BlockModelFenceGate<T extends BlockFenceGate> extends BlockModelSta
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.world, x, y, z);
+        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         boolean flag = true;
         int l = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
         boolean flag1 = BlockFenceGate.func_35291_d(l);
